%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Program obliczajcy splot dwch cigw wedug rnych algorytmw
% Wersja grudzie 2016
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
close all;
clear all;
clc;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wybieramy rodzaj sygnau
% 0 - ustalone wektory N=4
% 1 - ustalone wektory N=4 uzupenione zerami do 2N
% 2 - losowo generowane wektory N=8192
% 3 - losowo generowane wektory N=8192 uzupenione zerami do 2N
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SYGNAL=3;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wybieramy rodzaj splotu
% 0 - liniowy
% 1 - koowy
% 2 - szybki splot
% 3 - plot za pomoc funkcji conv
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
RODZAJ=2;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% cigi wejciowe
switch SYGNAL
    case 0
        x1=[2 1 2 1];
        x2=[1 2 3 4];
    case 1
        x1=[2 1 2 1 0 0 0 0];
        x2=[1 2 3 4 0 0 0 0];
    case 2
        x1=[rand(1,8192)];
        x2=[rand(1,8192)];
    case 3
        x1=[rand(1,8192) zeros(1,8192)];
        x2=[rand(1,8192) zeros(1,8192)];
    case 4
        x1=[rand(1,128) zeros(1,128)];
        x2=[rand(1,128) zeros(1,128)];
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% obliczamy iloci prbek cigw wejciowych
N=size(x1,2);
N1=size(x1,2);
N2=size(x2,2);
yl=zeros(1,2*N-1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
switch RODZAJ
    case 0
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % splot liniowy
        % splot w dziedzinie czasu realizujcy np. filtracj jednego 
        % sygnau przez filtr, ktrego odpowiedzi impulsow jest 
        % drugi sygna
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        tic
        % definicja tablicy wyjciowej
        y=zeros(1,N1+N2-1);
        % pierwsza ptla iterujca numer prbki cigu wyjciowego
        for n=0:(N1+N2-2)
            % zmienna kumulujca wynik
            suma=0;
            % druga ptla iterujca numery prbek ciagw wejciowych
            for k=0:N1-1
                % sprawdzamy, czy nie wychodzimy poza rozmiar ciagu
                % wejciowego
                if ((n-k)>=0&&(n-k)<N2)
                    % jeli nie, to obliczamy iloczyn przesunitych prbek
                    % i sumujemy
                    suma=suma+x1(k+1)*x2(n-k+1);
                end;    % koniec dla if ((n-k)>=0&&(n-k)<N)
            end;    % koniec dla for k=0:N-1
            % po wykonaniu sumowania wynik przypisujemy prbce cigu
            % wyjciowego
            y(n+1)=suma;
        end;    % koniec dla for n=0:2*N-2
        % wyznaczamy wektor numerw prbek
        n=0:2*N-2;
        toc
        % koniec splotu liniowego
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 1
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % splot koowy
        % matematycznie zgodny z wynikiem szybkiego splotu, jednak
        % realizowany w dziedzinie czasu
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % wyznaczamy dugoci cigw wejciowych
        N1=size(x1,2);
        N2=size(x2,2);
        % definicja tablicy wyjciowej na podstawie dugoci cigu x1
        yk=zeros(1,N1);
        % pierwsza ptla iterujca numer prbki cigu wyjciowego
        for n=0:N2-1
            % zmienna kumulujca wynik
            suma=0;
            % druga ptla iterujca numery prbek ciagw wejciowych
            for k=0:N1-1
                % sprawdzamy, czy nie wychodzimy poza rozmiar ciagu
                % wejciowego
                if ((k>=0)&&(k<N1))
                    % jeli 1nie, to obliczamy iloczyn przesunitych prbek
                    suma=suma+x1(k+1)*x2(mod(n-k,N2)+1);
                end;    % koniec dla if ((k>=0)&&(k<N1))
            end;    % koniec dla for k=0:N1-1
            yk(n+1)=suma;
        end;    % koniec dla for n=0:N2-1
        % wynik splotu koowego przypisujemy do zmiennej wyjciowej
        y=yk;
        % wyznaczamy wektor numerw prbek
        n=0:N-1;
        % koniec splotu koowego
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 2
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % szybki splot
        % czyli po prostu odwrotna FFT z iloczynu widm obu cigw
        % wynik jest zawsze zgodny z wynikiem splotu koowego w dziedzinie 
        % czasu, a z wynikiem splotu liniowego jedynie pod warunkiem
        % uzupenienia cigw wejciowych zerami do dugoci 2N
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        tic
        y=ifft(fft(x1).*fft(x2));
        toc
        % wyznaczamy wektor numerw prbek
        n=0:N-1;
    case 3
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % splot wykonywany za pomoc funkcji Matlaba conv()
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        y=conv(x1,x2);
        % wyznaczamy dugo cigu wynikowego
        N=size(y,2);
        % wyznaczamy wektor numerw prbek
        n=0:N-1;
        % koniec splotu conv()
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    case 4
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % splot w dziedzinie widma
        % czyli po prostu odwrotna DFT z iloczynu widm obu cigw
        % wynik jest zawsze zgodny z wynikiem splotu koowego w dziedzinie 
        % czasu, a z wynikiem splotu liniowego jedynie pod warunkiem
        % uzupenienia cigw wejciowych zerami do dugoci 2N
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        tic
        y=OPDFT(PDFT(x1).*PDFT(x2));
        toc
        % wyznaczamy wektor numerw prbek
        n=0:N-1;
    otherwise
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        % Wszystkie inne przypadki, czyli bdne wartoci staej RODZAJ
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        disp('Nie wybrano rodzaju splotu.')
        y=zeros(1,N);
        n=0:N-1;
        % koniec czci ohterwise
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Wykrelenie wynikw programu
figure;
bar(n,y);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

